import 'package:_private_core_network/network_resources/resources.dart';
import 'app_api.dart';
import 'models/contact_form_fields.dart';
import 'models/platform_user_detail.dart';
import 'models/platform_user_list.dart';

class CommonRepo {
  CommonRepo._();

  static CommonRepo? _instance;

  factory CommonRepo([MyAppApi? api]) {
    _instance ??= CommonRepo._();
    _instance!._api = api ?? MyAppApiImp();
    return _instance!;
  }

  late MyAppApi _api;

  Future<bool> trackOnClick(params) async {
    NetworkResponse response = await _api.trackOnClick(params);
    return response.data ?? false;
  }

  Future<PlatformUserList?> getPlatformsUsersFromAdmin(params) async {
    NetworkResponse response = await _api.getPlatformsUsersFromAdmin(params);
    return response.data;
  }

  Future<PlatformUserDetail?> getPlatformsUserDetailsFromAdmin(params) async {
    NetworkResponse response =
        await _api.getPlatformsUserDetailsFromAdmin(params);
    return response.data;
  }

  Future<List<ContactFormField>> getForms([params]) async {
    NetworkResponse response = await _api.getForms(params);
    return response.data;
  }

  Future<bool> fillForm(params) async {
    NetworkResponse response = await _api.fillForm(params);
    return response.data ?? false;
  }

  Future<String?> getCountryCodeFromLatLng(params) async {
    NetworkResponse response = await _api.getCountryCodeFromLatLng(params);
    return response.data;
  }

  Future<List<CurrencyAvailable>> getCurrencies() async {
    NetworkResponse response = await _api.getCurrencies();
    return response.data ?? [];
  }
  Future<List<DateFormatModel>> getDateFormatList() async {
    NetworkResponse response = await _api.getDateFormatList();
    return response.data ?? [];
  }

  Future<List<TimeFormatModel>> getTimeFormatList() async {
    NetworkResponse response = await _api.getTimeFormatList();
    return response.data ?? [];
  }
}
