import 'package:_private_core_network/network_resources/resources.dart';
import 'app_api.dart'; 

class CommonMediaRepo {
  CommonMediaRepo._();

  static CommonMediaRepo? _instance;

  factory CommonMediaRepo([MyAppApi? api]) {
    _instance ??= CommonMediaRepo._();
    _instance!._api = api ?? MyAppApiImp();
    return _instance!;
  }

  late MyAppApi _api; 

  Future<ListCommonMedia?> getMediasByFilter(params) async {
    NetworkResponse response = await _api.getMediasByFilter(params);
    return response.data;
  }

  Future<List<CommonMedia>> getMediaByPurpose(params) async {
    NetworkResponse response = await _api.getMediaByPurpose(params);
    return response.data ?? [];
  }

  Future<List<CommonMedia>> getMediaCat([params]) async {
    NetworkResponse response = await _api.getMediaCat(params);
    return response.data ?? [];
  }

  Future<CommonMedia?> uploadMedia(
      bytes, filePath, Map<String, dynamic> params) async {
    NetworkResponse response = await _api.uploadMedia(bytes, filePath, params);
    return response.data;
  }

  Future<CommonMedia?> createMediaCat(params) async {
    NetworkResponse response = await _api.createMediaCat(params);
    return response.data;
  }

  Future<CommonMedia?> updateMediaCat(params) async {
    NetworkResponse response = await _api.updateMediaCat(params);
    return response.data;
  }

  Future<CommonMedia?> updateMedia(
      bytes, filePath, Map<String, dynamic> params) async {
    NetworkResponse response = await _api.updateMedia(bytes, filePath, params);
    return response.data;
  }

  Future<bool> deleteMedia(params) async {
    NetworkResponse response = await _api.deleteMedia(params);
    return response.data ?? false;
  }

  Future<bool> deleteMediaCat(params) async {
    NetworkResponse response = await _api.deleteMediaCat(params);
    return response.data ?? false;
  } 
}
