import '../resources.dart';

class PaymentRepo {
  PaymentRepo._();

  static PaymentRepo? _instance;

  factory PaymentRepo([AppApi? api]) {
    _instance ??= PaymentRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<bool> updateOrderDetailsByAdmin(cardId) async {
    NetworkResponse response = await _api.updateOrderDetailsByAdmin(cardId);
    return response.data ?? false;
  }

  Future<List<PaymentMethod>> getPaymentMethodList(params) async {
    NetworkResponse response = await _api.getPaymentMethodList(params);
    return response.data ?? [];
  }

  Future<List<PaymentStatus>> getPaymentStatusList(params) async {
    NetworkResponse response = await _api.getPaymentStatusList(params);
    return response.data ?? [];
  }

  Future<List<PaymentOrder>> getOrdersFromProOrUser(params) async {
    NetworkResponse response = await _api.getOrdersFromProOrUser(params);
    return response.data ?? [];
  }

  Future<List<PaymentOrder>> getOrdersFromAdmin(params) async {
    NetworkResponse response = await _api.getOrdersFromAdmin(params);
    return response.data ?? [];
  }
}
